"""
Copyright 2008-2014 by Aerospike, Inc. All rights reserved.
THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE
ABOVE DOES NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION.
"""


# -*- coding: utf-8 -*-

from Crypto.Cipher import AES
import hashlib
import base64
import os

# the block size for the cipher object; must be 16, 24, or 32 for AES
BLOCK_SIZE = 32

# the character used for padding--with a block cipher such as AES, the value
# you encrypt must be a multiple of BLOCK_SIZE in length. This character is
# used to ensure that your value is always a multiple of BLOCK_SIZE
PADDING = '{'

# one-liner to sufficiently pad the text to be encrypted
pad = lambda s: s + (BLOCK_SIZE - len(s) % BLOCK_SIZE) * PADDING

# one-liners to encrypt/encode and decrypt/decode a string
# encrypt with AES, encode with base64
EncodeAES = lambda c, s: base64.b64encode(c.encrypt(pad(s)))
DecodeAES = lambda c, e: c.decrypt(base64.b64decode(e)).rstrip(PADDING)


# returns md5 hash of salted password
def hash_pass(password, salt):
    """
    Return the md5 hash of the password+salt
    """
    salted_password = password + salt
    return hashlib.md5(salted_password).hexdigest()


class TwoWayEncryption(object):

    def __init__(self):

        # generate a random secret key
        secret = os.urandom(BLOCK_SIZE)

        # create a cipher object using the random secret
        self._cipher = AES.new(secret)

    def get_cipher(self):
        return self._cipher

    def encrypt(self, decoded):
        return EncodeAES(self._cipher, decoded)

    def decrypt(self, encoded):
        return DecodeAES(self._cipher, encoded)




